<?php

namespace SCM\Services;

use SCM\Traits\TQuery;

class Cardapio {
    
    use TQuery;

    private $entityManager;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function retornaPratosCardapios($centrais, $filiais, $dtInicial, $dtFinal, $nrorg) {

        $dataSet = array();

    	$sql = "SELECT CDFILCENTPME, NRCARDPME, DSCARDPME, DTINICARDPME, DTFINCARDPME, CDTIPOCARD
          FROM CARDAPIOPME C
         WHERE 
         INSTR(:CDFILCENTPME, C.CDFILCENTPME) <> 0
         AND NRORG = :NRORG
           AND (C.DTINICARDPME BETWEEN :DTINI AND :DTFIM
           OR C.DTFINCARDPME BETWEEN :DTINI AND :DTFIM
           OR :DTINI BETWEEN C.DTINICARDPME AND C.DTFINCARDPME
           OR :DTFIM BETWEEN C.DTINICARDPME AND C.DTFINCARDPME)";

        $params = array(
            'NRORG' => $nrorg,
            'CDFILCENTPME' => $centrais,
            'DTINI' => $dtInicial,
            'DTFIM' => $dtFinal,
        );
        $cardapiosDatas = $this->entityManager->getConnection()->fetchAll($sql, $params);
        
        $sqlPratos = "SELECT CC.CDFILCENTPME, CC.NRCARDPME, CC.NRCARDIAPME, :CDFILIAL AS CDFILIAL, CD.CDSERVFILI,
                   TO_CHAR(CD.DTCARDIAPME, 'DD/MM/YYYY') AS DTCARDIAPME, CC.NRSEQPRACPME, CC.NRORDPRACPME, CC.CDFILAUXPRAT, CC.CDPRATO, PT.NMPRATO,
                   CC.CDTIPOPRAT, CC.VRPECONSCPME, CD.IDTIPO,
                   CC.CDFILCENTPME || CC.NRCARDPME || CC.NRCARDIAPME || :CDFILIAL || CD.CDSERVFILI || TO_CHAR(CD.DTCARDIAPME, 'DDMMYYYY') || CC.CDPRATO AS KEY
              FROM PRATO PT, COMPCARDPME CC, 
                   (SELECT 'P' IDTIPO, CDFILCENTPME, NRCARDPME, NRCARDIAPME, CDFILIAL, DTCARDIAPME, CDSERVFILI 
                      FROM CARDIAPME P 
                     WHERE INSTR(:CDFILCENTPME, P.CDFILCENTPME) <> 0
                     AND (P.NRCARDPME = :NRCARDPME) 
                       AND (P.CDFILIAL = P.CDFILCENTPME) 
					   AND DTCARDIAPME BETWEEN :DTINI AND :DTFIM
                       AND NOT EXISTS(SELECT CDFILIAL FROM CARDIAPME C 
                                       WHERE (C.CDFILCENTPME = P.CDFILCENTPME) AND (C.NRCARDPME = P.NRCARDPME) 
                                         AND (C.CDSERVFILI = P.CDSERVFILI) AND (C.CDFILIAL = :CDFILIAL) 
                                         AND (C.DTCARDIAPME = P.DTCARDIAPME) AND (C.IDCARDESPEC = 'S') )
                     UNION ALL 
                    SELECT 'E' IDTIPO, CDFILCENTPME, NRCARDPME, NRCARDIAPME, CDFILIAL, DTCARDIAPME, CDSERVFILI 
                      FROM CARDIAPME 
                     WHERE INSTR(:CDFILCENTPME, CDFILCENTPME) <> 0
                     AND (NRCARDPME = :NRCARDPME) 
					   AND DTCARDIAPME BETWEEN :DTINI AND :DTFIM
                        AND (CDFILIAL = :CDFILIAL) AND (IDCARDESPEC = 'S')) CD 
               WHERE (CC.CDFILCENTPME = CD.CDFILCENTPME) AND (CC.NRCARDPME = CD.NRCARDPME) 
                 AND (CC.NRCARDIAPME = CD.NRCARDIAPME) AND (PT.CDFILAUXPRAT = CC.CDFILAUXPRAT) 
                 AND (PT.CDPRATO = CC.CDPRATO) ORDER BY 5, 7";
                 /*(P.CDFILCENTPME = :CDFILCENTPME) */
                 /*(P.CDSERVFILI = :CDSERVFILI) AND */
                 /*(CDFILCENTPME = :CDFILCENTPME) */
                 /*AND (CDSERVFILI = :CDSERVFILI)*/
        
        if (is_string($filiais)) $filiais = explode('_', $filiais);
        $cardapiosDatasFiliais = [];
        foreach($filiais as $filial) {
            foreach($cardapiosDatas as $cardapio) {
                $aux = $cardapio;
                $aux['CDFILIAL'] = $filial;
                $aux['KEY'] = $cardapio['CDFILCENTPME'].$filial.$cardapio['CDTIPOCARD'].$cardapio['NRCARDPME'];
                $cardapiosDatasFiliais[] = $aux;
            }
        }
        // echo json_encode($cardapiosDatasFiliais);die;
        // $pratosCardapios = [];
        foreach($cardapiosDatasFiliais as &$cardapioFilial) {
            $paramsPratos = array(
                'CDFILIAL' => $cardapioFilial['CDFILIAL'],
                'DTINI' => $dtInicial,
                'NRCARDPME' => $cardapioFilial['NRCARDPME'],
                'CDFILCENTPME' => $centrais,
                'DTFIM' => $dtFinal,
            );
            $cardapioFilial['PRATOS'] = $this->entityManager->getConnection()->fetchAll($sqlPratos, $paramsPratos);
        }
        return $this->buildResponseData($cardapiosDatasFiliais);
    }
}